#include "../CMemoryLeaks/CMemoryLeaks.h"

#include <stdlib.h>


//si compilamos con c++ es obligatorio inicializar/definir aqui la variables
CMemoryLeaks* CMemoryLeaks::mspInstancia = nullptr;
std::mutex CMemoryLeaks::msMutex;


CMemoryLeaks::CMemoryLeaks(void)
{
}

CMemoryLeaks::~CMemoryLeaks(void)
{
}


CMemoryLeaks *CMemoryLeaks::getInstance(void)
{
 //bloqueamos el acceso a la parte de código critica.
 CMemoryLeaks::msMutex.lock();
 if (CMemoryLeaks::mspInstancia==nullptr)
 {
  //no hay instancia, la creamos
  CMemoryLeaks::mspInstancia=new CMemoryLeaks();
 }
 //desbloquemoas la parte del código crítica
 CMemoryLeaks::msMutex.unlock();

 //devolvemos la instancia
 return CMemoryLeaks::mspInstancia;
}

std::string *CMemoryLeaks::finalizar(void)
{
 std::map <UINT_PTR,std::string> lMap;
 std::map <UINT_PTR,std::string>::const_iterator lIter;
 //string donde dejaremos los registros
 std::string *lpstrAviso;


 lpstrAviso=NULL;

 if (CMemoryLeaks::mspInstancia!=nullptr)
 {
  lMap=CMemoryLeaks::mspInstancia->getMap();
  if (lMap.size()!=0)
  {//tengo registros en el mapa
   for (lIter=lMap.begin();lIter!=lMap.end();lIter++ )
   {//recorro todos los registros y los voy concatenando en el std::string
    if (lpstrAviso==NULL)
     lpstrAviso=new std::string(lIter->second);
    else
       lpstrAviso->append(lIter->second);
    //añado el retorno de carro
    lpstrAviso->append("\n");
   }//fin for recorre los registros del mapa

   lMap.clear();

   //borramos la instancia
   delete CMemoryLeaks::mspInstancia;
   CMemoryLeaks::mspInstancia=nullptr;
  }//fin tengo registros en el mapa
 }


 return lpstrAviso;
}

void CMemoryLeaks::crear(UINT_PTR pDirMem,std::string pstrFile,
			   std::string pstrfuncion, unsigned int puiLine,
			   std::string pstrInf)
{
 std::map <UINT_PTR,std::string>::const_iterator lIter;
 std::string lstr;

 //busco si existe un registro para la direccion de memoria (pDirMen)
 lIter=mpMap.find(pDirMem);
 if (lIter==mpMap.end())
 {//no hay registro inserto un registro en el mapa
  //bloqueo el acceso al mapa.
  CMemoryLeaks::msMutex.lock();
  lstr=pstrFile+":"+pstrfuncion+":"+std::to_string(puiLine)+": "+pstrInf;
  //inserto la tupla (direccion memoria(clave), texto(dato))
  mpMap.insert(std::map <UINT_PTR,std::string>::value_type(pDirMem,lstr));
  //desbloqueo el acceso al mapa
  CMemoryLeaks::msMutex.unlock();
 }
}

void CMemoryLeaks::liberar(UINT_PTR pDirMem)
{
 std::map <UINT_PTR,std::string>::const_iterator lIter;

 //busco si existe un registro para la direccion de memoria (pDirMen)
 lIter=mpMap.find(pDirMem);
 if (lIter!=mpMap.end())
 {//hay registro borro el registro
  //bloqueo el acceso al mapa.
  CMemoryLeaks::msMutex.lock();
  //borro la tupla encontrada
  mpMap.erase(lIter);
  //desbloqueo el acceso al mapa
  CMemoryLeaks::msMutex.unlock();
 }
}


std::map <UINT_PTR,std::string> CMemoryLeaks::getMap(void)
{
 return mpMap;
}

